require 'love.image'
--require 'love.filesystem'
--tc = require 'newtc'
local tc	= {}

tc.thread = {}
tc.thread.ReceiveChannel	= love.thread.getChannel( 'toThread' )
tc.thread.SendChannel		= love.thread.getChannel( 'fromThread' )

function tc.thread.receive()	-- thread loops until data received
	print( 'thread: waiting' )
	local dat	= nil
	while not dat do dat = tc.thread.ReceiveChannel:demand() end
	print( 'thread: received '.. type( dat ) )
	tc.thread.SendChannel:push( dat )	-- confirm receiving without expecting response
	return dat
	end

function tc.thread.send( dat )
	print( 'thread: sending '..type( dat ) )
	tc.thread.SendChannel:push( dat )
	print( 'thread: '..type( dat )..' sent' )
	local Received = false		-- delay until received
	while not Received do Received = tc.thread.receive() end
	end

print( 'thread started' )

local msg = tc.thread.receive()
	print('thread: message = '..msg)

local funk = tc.thread.receive()	-- receive function to process imagedata
	loadstring( funk )( )

local imageData = tc.thread.receive()

imageData:mapPixel( process )	-- assumes function name is 'process'
	print( 'thread: imagedata processed' )

tc.thread.send( imageData )
collectgarbage( 'collect' )		-- overcome memory leak

print( 'thread: no longer active!' )


